import pygame
from pygame.locals import *
import sys

import cursor

class Clear():
    def __init__(self):
        self.select = 0
        self.clear_font = pygame.font.Font("data/minamoji04.ttf", 48)
        self.menu_font = pygame.font.Font("data/minamoji04.ttf", 32)

        self.clear = self.clear_font.render(u"STAGE CLEAR", True, (255, 255, 255))
        self.retry = self.menu_font.render(u"もう一度", True, (255, 255, 255))
        self.exit = self.menu_font.render(u"やめる", True, (255, 255, 255))

        self.cursor = cursor.Cursor(220, 230, (255, 255, 255))

    def update(self):
        if self.select == 0:
            self.cursor.y = 230
        elif self.select == 1:
            self.cursor.y = 280

    def draw(self, screen):
        screen.fill((0, 0, 0))
        screen.blit(self.clear, ((320 - (self.clear.get_width() / 2)), 100))
        screen.blit(self.retry, ((320 - (self.retry.get_width() / 2)), 225))
        screen.blit(self.exit, ((320 - (self.exit.get_width() / 2)), 275))
        self.cursor.draw(screen)
