import pygame
from pygame.locals import *
import math
import random

import tools, shot

class Enemy(pygame.sprite.Sprite):
    speed = 5

    # prob_atkを引数に追加
    def __init__(self, time, image, pos, move_type, hp, name, prob_atk):
        pygame.sprite.Sprite.__init__(self, self.containers)
        self.frame = 0
        self.time = time
        self.image = tools.load_image("data/enemy", image + ".png", -1)
        self.rect = self.image.get_rect()
        self.rect.center = pos
        self.move_type = move_type
        self.exist = False
        self.hp = hp
        self.name = name
        self.prob_atk = prob_atk

    def update(self):
        self.frame += 1
        if self.frame > self.time:
            self.exist = True

        if self.exist == True:
            if self.move_type == 0:
                self.rect.move_ip(-2, 0)
                if self.rect.center[0] < -32:
                    self.kill()
            
            # 乱数を発生させ、prob_atk以下なら攻撃
            if random.random() < self.prob_atk:
                shot.Missile(self.rect.center)

    def draw(self, screen):
        screen.blit(self.image, self.rect)

class Boss(Enemy):
    def __init__(self):
        super().__init__(400, "tanuragon", (704, 240), None, 10, "タヌラゴン", 0.07)
        self.circle = False
        self.angle = 90
    
    def update(self):
        self.frame += 1
        if self.frame > self.time:
            self.exist = True

        if self.exist == True:
            if self.circle == False:
                self.rect.move_ip(-self.speed, 0)
                if self.rect.left < 440:
                    self.circle = True
            else:
                self.vx = int(3 * math.cos(math.radians(self.angle)))
                self.vy = int(3 * math.sin(math.radians(self.angle)))
                self.rect.move_ip(self.vx, self.vy)
                self.angle += self.speed
            
            if random.random() < self.prob_atk:
                shot.Missile(self.rect.center)

